unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ExtCtrls, ComCtrls,
  StdCtrls, inifiles;

type

  { TForm1 }

  TForm1 = class(TForm)
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    ComboBox1: TComboBox;
    CoolBar1: TCoolBar;
    ImageList1: TImageList;
    Memo1: TMemo;
    Panel1: TPanel;
    ToolBar1: TToolBar;
    ToolBar2: TToolBar;
    ToolBar3: TToolBar;
    ToolButton1: TToolButton;
    ToolButton10: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    ToolButton8: TToolButton;
    ToolButton9: TToolButton;
    procedure CheckBoxChange(Sender: TObject);
    procedure CoolBar1Change(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
  private
    procedure ReadIni;
    procedure WriteIni;

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.CheckBoxChange(Sender: TObject);
var
  checkbox: TCheckbox;
  band: TCoolBand;
  i: Integer;
begin
  checkbox := Sender as TCheckbox;
  for i := 0 to Coolbar1.Bands.Count-1 do
  begin
    band := Coolbar1.Bands[i];
    if band.ID = checkbox.Tag then
      band.Visible := checkbox.Checked;
  end;
end;

procedure TForm1.CoolBar1Change(Sender: TObject);
var
  i: Integer;
begin
  Memo1.Lines.Add('OnChange');
  for i := 0 to Coolbar1.Bands.count-1 do
  begin
    Memo1.Lines.Add(Format('  Bands[%d]: ID=%d Control=%s  Break=%s   Visible=%s', [
      i,
      Coolbar1.Bands[i].ID,
      Coolbar1.Bands[i].Control.Name,
      BoolToStr(Coolbar1.Bands[i].Break, true),
      BoolToStr(Coolbar1.Bands[i].Visible, true)
    ]));
  end;

end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  if CanClose then
    try
      WriteIni;
    except
    end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  ReadIni;
end;

procedure TForm1.ReadIni;
var
  ini: TIniFile;
  band: TCoolBand;
  i, j, id: Integer;
  s: String;
  sa: TStringArray;
begin
  ini := TIniFile.Create(ChangeFileExt(Application.ExeName, '.ini'));
  try
    Coolbar1.DisableAutoSizing;
    for i := 0 to Coolbar1.Bands.Count-1 do
    begin
      band := Coolbar1.Bands[i];
      s := ini.ReadString('Coolbar', 'Band' + IntToStr(i), '');
      sa := s.Split(',');
      id := StrToInt(sa[0]);
      for j := i+1 to Coolbar1.Bands.Count-1 do
        if Coolbar1.Bands[j].ID = id then
        begin
          Coolbar1.Bands[j].Index := i;
          break;
        end;
    end;
    for i := 0 to Coolbar1.Bands.Count-1 do
    begin
      band := Coolbar1.Bands[i];
      s := ini.ReadString('Coolbar', 'Band' + IntToStr(i), '');
      sa := s.Split(',');
      band.Break := StrToInt(sa[1]) <> 0;
      band.Visible := StrToInt(sa[2]) <> 0;
      case band.ID of
        0: Checkbox1.Checked := band.Visible;
        1: Checkbox2.Checked := band.Visible;
        2: Checkbox3.Checked := band.Visible;
      end;
    end;
    Coolbar1.EnableAutoSizing;

    Coolbar1Change(nil);
  finally
    ini.Free;
  end;
end;

procedure TForm1.WriteIni;
var
  ini: TIniFile;
  s: String;
  band: TCoolband;
  i: Integer;
begin
  ini := TIniFile.Create(ChangeFileExt(Application.ExeName, '.ini'));
  try
    for i := 0 to Coolbar1.Bands.Count-1 do begin
      band := Coolbar1.Bands[i];
      s := Format('%d,%d,%d', [band.ID, ord(band.Break), ord(band.Visible)]);
      ini.WriteString('Coolbar', 'Band' + IntToStr(i), s);
    end;
  finally
    ini.Free;
  end;
end;

end.

